/*
 * Copyright 2018 - 2019 Volker Berlin (i-net software)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.inetsoftware.jwebassembly.binary;

import java.io.IOException;

import de.inetsoftware.jwebassembly.wasm.AnyType;

/**
 * An entry in the global section of the WebAssembly.
 * 
 * @author Volker Berlin
 */
class Global extends SectionEntry {

    int id;

    AnyType type;

    boolean mutability;

    /**
     * {@inheritDoc}
     */
    @Override
    void writeSectionEntry( WasmOutputStream stream ) throws IOException {
        stream.writeRefValueType( this.type );
        stream.write( this.mutability ? 1 : 0 );
        stream.writeDefaultValue( this.type );
        stream.writeOpCode( InstructionOpcodes.END );
    }
}
